Require Import paco.
Require Import external.

(*
  Using cofix
 *)

CoInductive A f : Prop := foldA 
  (P: Prop) (LE: P -> A f) (IN: f (f P)).

Lemma foo: forall (f: Prop->Prop) (MON: monotone0 f) (id: forall x : Type, x -> x),
  forall P: Prop, (P -> f (f P)) -> P -> A f.
Proof.
  (* The following script succeeds, but fails at Qed 
     because the constructed proof is not guarded.

     cofix CIH; intros; eapply foldA; eauto. 
  *)

  (* The following script constructs a correct guarded proof. *)
  cofix CIH; intros; eapply foldA; [apply CIH|]; eauto.
Qed.

(*
  Using parameterized coinduction
 *)

Inductive PAgen f (r: Prop) : Prop := foldPAgen 
  (P: Prop) (LE: P -> r) (IN: f (f P)).
Hint Constructors PAgen.

(* the internal library approach *)
Goal forall (f: Prop->Prop) (MON: monotone0 f),
  forall P: Prop, (P -> f (f P)) -> P -> paco0 (PAgen f) bot0.
Proof.
  pcofix CIH; eauto 7.
Qed.

(* the external library approach 
  - you need to hack to make external approach go along with automation
 *)

Hint Extern 3 (@cola_join _ _ _) => red; repeat red.

Goal forall (f: Prop->Prop) (MON: monotone0 f),
  forall P: Prop, (P -> f (f P)) -> P -> G (PAgen f) bot0.
Proof.
  intros f; pcofix CIH using (G_acc (PAgen f)).
  eauto 7 using (fun r x => G_fold (PAgen f) r x).
Qed.

